/**
 *	Copyright (C) 2011 Docuteam GmbH
 *
 *	This program is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 3
 *	as published by the Free Software Foundation.
 *	
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *	
 *	You should have received a copy of the GNU General Public License
 *	along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 *	Copyright (C) 2011 Docuteam GmbH
 *
 *	This program is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 3
 *	as published by the Free Software Foundation.
 *	
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *	
 *	You should have received a copy of the GNU General Public License
 *	along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package ch.docuteam.docutools.admin;

/**
 * @author denis
 * 
 * CHANGES HISTORY:
 * 
 * 1.4.3 (Andreas, 05.12.2011):
 * 
 * 
 * 1.4.2 (Andreas, 01.12.2011):
 * LDAP client.
 * 
 * 1.4.1 (Denis, 16.11.2011):
 * out.Logger: Don't use environment variable "LOGGER_HOME" any more, but the static method setConfigFile(String) to set the log4j config file.
 * build.xml: Rename project from DocuTools to Docutools.
 * Insert copyright message into all sources.
 * 
 * 1.4.0 (Denis, 07.11.2011):
 * Changed the *interface* of class file.FileUtil: Introduce methods copyToOverwriting(...) and copyToMerging(...), remove method copyTo(...).
 * 
 * 1.3.18 (Denis, 07.11.2011):
 * Correction in class file.FileUtil: copying a folder now overwrites any existing destination folder (before, it merged).
 * 
 * 1.3.17 (Denis, 03.11.2011):
 * Correction in class file.MetadataProviderDROID: close file after getting the metadata, so no locks remain on this file.
 * 
 * 1.3.16 (Denis, 02.11.2011):
 * Correction in class file.FileUtil: deleting and renaming a file are now retried 20 times, with 1/2 secs delay in-between.
 * Correction in class util.SystemProcess: cleanup all objects thoroughly after work is done. There are some weird problems with locked files under windows.
 * 
 * 1.3.15 (Denis, 01.11.2011):
 * Added classes: FileChecksumCalculator, FileWithMetadata, MetadataProviderDROID, MetadataProviderJHOVE, MetadataFromJPGFile (moved from Docudarc to here)
 * Replaced required EnvironmentVariable "DOCUDARC_HOME" by "DOCUTOOLS_HOME". This is needed to locate the files DROID_SignatureFile_V52.xml and jhove.conf.
 * 
 * 1.3.14 (Denis, 19.10.2011):
 * Added class: string.StringValueComparator, which compares string not lexographically but like integers, so that "10" > "9" is true.
 * Added class: util.Sound, which can play AIF files.
 * 
 * 1.3.13 (Denis, 19.10.2011):
 * Modified class I18N: marked method get(String) as deprecated, use method translate(String) instead. Added method translate(String, Object...) for additional parameters.
 * 
 * 1.3.12 (Denis, 10.10.2011):
 * Modified class MySQLJDBCConnection: added method getConnection(), and the create(...) methods now return the created connection.
 * 
 * 1.3.11 (Denis, 20.09.2011):
 * Corrected method string.StringUtil.increment(String s): increment now 999 to 1000 instead of 9910.
 * 
 * 1.3.10 (Denis, 19.09.2011):
 * Added no-argument methods trace(), debug(), info(), warn(), error(), and fatal() to class out.Logger.
 * Added method increment(String s) to class string.StringUtil.
 * 
 * 1.3.9 (Denis, 12.09.2011):
 * Added method beep() to class OperatingSystem.
 * Added methods isNumeric(), isAlphaNumeric(), and isAlpha() to class StringUtil.
 * 
 * 1.3.8 (Denis, 29.08.2011):
 * Added classes gui.LimitedTextField and gui.LimitedIntegerTextField.
 * 
 * 1.3.7 (Denis, 26.08.2011):
 * Extended class StringUtil with the methods first(i), last(i), and splitQuoted(*).
 * Extended in class StringUtil the method split() with additional boolean parameter ignoreEmptyTokens, and added methods split(*) with default parameters.
 * 
 * 1.3.6 (Denis, 28.07.2011):
 * Renamed folder config_gen to config_dist and adapted build.xml accordingly.
 * Extended class SystemOutView with a constructor where the header message can be specified.
 * 
 * 1.3.5 (Denis, 26.07.2011):
 * Fixed a bug in class JTableWithDynamicToolTipTexts: a NullPointerException was thrown when the object returned as toolTipText was null.
 * 
 * 1.3.4 (Andreas, 22.07.2011):
 * Updated truezip libraries to work with zip files >4GB
 * 
 * 1.3.3 (Denis, 30.06.2011):
 * file.CSVFileReader: Modified so that the CSVFileReader can handle separators within quotes, and masked quotes
 * 
 * 1.3.2 (Denis, 21.06.2011):
 * util.OperatingSystem: corrections.
 * 
 * 1.3.1 (Denis, 20.06.2011):
 * Added class util.OperatingSystem.
 * 
 * 1.3.0 (Denis, 17.06.2011):
 * Changed the *interface* of class util.SystemProcess so that VarArgs can be used (either execute(new String[]{"a", "b", "c"}) or (new) execute("a", "b", "c")).
 * 
 * 1.2.15 (Denis, 16.06.2011):
 * Corrected class util.SystemProcess to be able to open under Windows files externally whose filename doesn't start with a drive identifier (like "C:").
 * 
 * 1.2.14 (Denis, 15.06.2011):
 * Added class gui.JTableWithDynamicToolTipTexts, which is a subclass of JTable. It can be configured that for some columns, the cell content is displayed as the cell's toolTipText.
 * Extended class string.StringUtil with methods for trimming string (trimLeft, trimRight, trimLeftAndRight, trimMid, trimAll).
 * Cleanup: Corrected some code showing warnings.
 * 
 * 1.2.13 (Andreas, 09.06.2011):
 * Use TrueZip (64Bit)
 * 
 * 1.2.12 (Denis, 08.06.2011):
 * Extended class string.DateFormatter to format dates in 'long' format (java primitive numeric data structure containing the number of milliseconds since January 1, 1970, 00:00:00 GMT).
 * Extended class file.FileUtil with the method getFileContentAsString().
 * 
 * 1.2.11 (Andreas, 08.06.2011):
 * Added timeout to file operations
 * 
 * 1.2.10 (Denis, 30.05.2011):
 * Fixed bug in util.SystemProcess: Opening in windows a file whose address starts with "http://" now works.
 * 
 * 1.2.9 (Denis, 23.05.2011):
 * Extended class string.StringUtil with the methods asFileNameWithoutExtension(...) and asFileNameExtension(...).
 * 
 * 1.2.8 (Denis, 15.04.2011):
 * Extended class util.SystemProcess with the method openExternally(...).
 * Added class util.SystemProcessException.
 * 
 * 1.2.7 (Denis, 08.04.2011):
 * Added class exceptions.FileIsNotADirectoryException, which gets thrown in util.SystemProcess.
 * 
 * 1.2.6 (Denis, 06.04.2011):
 * Added class util.EnvironmentVariable.
 * Added class util.SystemProcess.
 * 
 * 1.2.5 (Denis, 25.03.2011):
 * Added class file.FileFilter.AllFilesExceptHidden.
 * 
 * 1.2.4 (Denis, 22.03.2011):
 * Added Log messages to file.FileUtil.
 * 
 * 1.2.3 (Denis, 15.03.2011):
 * Extended class file.Zipper with the method zip(String sourcePath, String zipFilePath, boolean skipTopFolder) for zipping a folder excluding the top level folder.
 * 
 * 1.2.2 (Denis, 15.03.2011):
 * Added abstract class string.StringUtil with many useful methods for Strings.
 * 
 * 1.2.1 (Denis, 11.03.2011):
 * Improved util.Exception and util.ExceptionCollectorException to be better readable for the user.
 * 
 */
public abstract class Version
{
	static public final String Product = "Docutools";
	static public final String Number = "1.4.3";
	static public final String LastChange = "05.12.2011";

	/**
	 * This main method is being used by the ant build script to be able to add a version number to the compiled jar file.
	 * 
	 * @param args: No parameters are expected.
	 */
	public static void main(String[] args)
	{
		System.out.println(Number);
	}
}
